-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE.
call alta_circuit("testcircuit", 'test_sobrenom', 6666, 'ES', @RSP);
SELECT @RSP;

-- ERROR: Nom del circuit repetit.
call alta_circuit("testcircuit", 'test_sobrenom', 6666, 'ES', @RSP);
SELECT @RSP;

-- ERROR: Sobrenom del circuit repetit.
call alta_circuit("circuit_diferent", 'test_sobrenom', 6666, 'ES', @RSP);
SELECT @RSP;

-- ERROR: Codi pais inexistent.
call alta_circuit("circuit_diferent", 'sobrenom_diferent', 6666, 'XX', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE.
call alta_telemetria(115,'2015-01-15','velocitat', FLOOR(RAND()*(400-0)+0),'kmh', @RSP);
SELECT @RSP;

-- ERROR: Codi component inexistent.
call alta_telemetria(1115,'2015-01-15','velocitat', FLOOR(RAND()*(400-0)+0),'kmh', @RSP);
SELECT @RSP;

-- ERROR: Data sense cursa (només es poden generar dades a les curses).
call alta_telemetria(115,'2066-01-15','velocitat', FLOOR(RAND()*(400-0)+0),'kmh', @RSP);
SELECT @RSP;

-- ERROR: Trigger velocitat massa gran.
call alta_telemetria(115,'2015-01-15','velocitat', 650,'kmh', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE.
call alta_component (1,1,'TestComp','Prova descripció', @RSP);
SELECT @RSP;

-- ERROR: Query amb fabricant incorrecte.
call alta_component (6666,1,'TestComp','Prova descripció', @RSP);
SELECT @RSP;

-- ERROR: Query amb model de cotxe incorrecte.
call alta_component (1,6666,'TestComp','Prova descripció', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE.
call alta_retransmissio (12,'ES',6, @RSP);
SELECT @RSP;


-- ERROR: L'emissora no emet a aquest país (només a ES).
call alta_retransmissio (12,'UK',6, @RSP);
SELECT @RSP; 

-- ERROR: País inexistent.
call alta_retransmissio (12,'XX',6, @RSP);
SELECT @RSP;

-- ERROR: Emissora inexistent.
call alta_retransmissio (666,'UK',6, @RSP);
SELECT @RSP;

-- ERROR: Competició inexistent.
call alta_retransmissio (12,'UK',666, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE.
call alta_temporada (2018, 1, @RSP);
SELECT @RSP;


-- ERROR: Temporada en ús.
call alta_temporada (2015, 1, @RSP);
SELECT @RSP;

-- ERROR: Competició inexistent.
call alta_temporada (2015, 666, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE.
call alta_competicio('testcomp_alta','TCA','Prova descripció', @RSP);
SELECT @RSP;


-- ERROR: Nom de competició en ús (acrònim nou).
call alta_competicio('World Rally Championship','NT','Prova descripció', @RSP);
SELECT @RSP;

-- ERROR: Acrònim en ús (nom nou).
call alta_competicio('testcomp_diferent','F1','Prova descripció', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE.
call alta_patrocini (1, 11, 2015, 6666333, @RSP);
SELECT @RSP;


-- ERROR: Patrocini en ús.
call alta_patrocini (1, 11, 2015, 6666333, @RSP);
SELECT @RSP;

-- ERROR: Patrocinador inexistent.
call alta_patrocini (666, 11, 2015, 6666333, @RSP);
SELECT @RSP;

-- ERROR: Equip inexistent.
call alta_patrocini (1, 666, 2015, 6666333, @RSP);
SELECT @RSP;

-- ERROR: Temporada  inexistent.
call alta_patrocini (1, 11, 2066, 6666333, @RSP);
SELECT @RSP;

-- ERROR: Cost massa petit (trigger).
call alta_patrocini (1, 11, 2015, 630, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE.

-- AVÍS: aquest insert produeix un error de vegades però realitza tots els passos correctament
-- Sembla un bug al error handler de MySQL

call alta_sector ('Tela marinera', @RSP);
SELECT @RSP;


-- ERROR: Nom en ús.
call alta_sector ('Banca', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE .
call alta_patrocinador (4,'Sóc banquer', @RSP);
SELECT @RSP;


-- ERROR: Patrocinador en ús.
call alta_patrocinador (4,'Sóc banquer', @RSP);
SELECT @RSP;

-- ERROR: Sector inexistent.
call alta_patrocinador (666,'Nan banquero', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE .
call alta_pais ('ZZ', 'Peteronia', @RSP);
SELECT @RSP;


-- ERROR: Nom del país en ús.
call alta_pais ('ZX', 'Peteronia', @RSP);
SELECT @RSP;

-- ERROR: Codi del país en ús.
call alta_pais ('ZZ', 'Diferent', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE.
call alta_fabricant('Sóc fabricant', 1960, @RSP);
SELECT @RSP;

-- ERROR: Nom del fabricant en ús.
call alta_fabricant('Sóc fabricant', 1960, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE .
call alta_equip ('Scuderia nova', 'Barcelona', '2015-12-25', @RSP);
SELECT @RSP;


-- ERROR: Nom de léquip en ús.
call alta_equip ('Scuderia NAN', 'Barcelona', '2015-12-25', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE (dues emissores del mateix nom a diferents països és permés).
call alta_emissora ('emissora-test', 'ES', @RSP);
SELECT @RSP;
call alta_emissora ('emissora-test', 'CH', @RSP);
SELECT @RSP;


-- ERROR: Nom d'emissora en ús per aquest país.
call alta_emissora ('ATV', 'HK', @RSP);
SELECT @RSP;

-- ERROR: País inexistent.
call alta_emissora ('emissora-diferent', 'XX', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE
call alta_pilot ('Test_pilot', 'ES', 3, 'TS123456', 2015, @RSP);
SELECT @RSP;


--  ERROR: Nom del pilot en ús.
call alta_pilot ('Jarno Trulli', 'ES', 3, 'TS123456', 2015, @RSP);
SELECT @RSP;

-- ERROR: País inexistent.
call alta_pilot ('Test_pilot nou', 'XX', 3, 'TS123456', 2015, @RSP);
SELECT @RSP;

-- ERROR: Equip inexistent.
call alta_pilot ('Test_pilot nou', 'ES', 666, 'TS123456', 2015, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE
call alta_director ('Test_director', 'ES', 6, 'Mechanical engineer', 2015, @RSP);
select @RSP;


-- ERROR: Nom del director en ús.
call alta_director ('Frank Williams', 'ES', 7, 'Mechanical engineer', 2015, @RSP);
select @RSP;

-- ERROR: L'equip ja té director.
call alta_director ('Nou director', 'ES', 6, 'Mechanical engineer', 2015, @RSP);
select @RSP;

-- ERROR: Equip inexistent.
call alta_director ('Nou director', 'ES', 666, 'Mechanical engineer', 2015, @RSP);
select @RSP;

-- ERROR: País inexistent.
call alta_director ('Nou director', 'XX', 6, 'Mechanical engineer', 2015, @RSP);
select @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE
call alta_cursa (1, 6, 1, 5, '2015-04-04', @RSP);
select @RSP;


-- ERROR: Circuit inexistent
call alta_cursa (12121, 6, 1, 1, '2014-04-04', @RSP);

-- ERROR: Pilot inexistent
call alta_cursa (1, 6343, 1, 1, '2014-04-04', @RSP);

-- ERROR: Competició inexistent
call alta_cursa (1, 6, 21212, 1, '2014-04-04', @RSP);

-- ERROR: Data inexistent
call alta_cursa (1, 6, , 1, '6555-04-04', @RSP);
select @RSP;

-- ERROR: Any existent (2015) pero no per aquesta competicio (2)
call alta_cursa (1, 6, 2, 5, '2014-04-04', @RSP);
select @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- QUERY CORRECTE
call alta_cotxe ('Model nou', 2015,3, 2015, @RSP);
select @RSP;

-- ERROR: Temporada inexistent .
call alta_cotxe ('Model nou 2', 2015,3, 2066, @RSP);
select @RSP;

-- ERROR: Nom del cotxe en ús.
call alta_cotxe ('SF15-T', 2015,3, 2015, @RSP);
select @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------
