-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA CIRCUIT preparacio
call alta_cursa (76, 10, 1, 5, '2015-05-04', @RSP);
select @RSP;

-- QUERY CORRECTE (esborra el circuit 76 i també cursa anterior)
call baixa_circuit (76, @RSP);
SELECT @RSP;

-- ERROR: Codi del circuit inexistent
call baixa_circuit (974, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA COMPETICIO preparacio

-- A l'script INSERIR_DADES s'ha inserit la competició 'testcomp_baixa' per fer aquesta prova

-- Crear una temporada (2018) per la competició 'testcomp_baixa' (codi competició 11)
call alta_temporada (2018, 11, @RSP);
SELECT @RSP;

-- Crear una cursa per aquesta competició (codi competici 11) i temporada (2018)
call alta_cursa (5, 10, 11, 5, '2018-06-04', @RSP);
select @RSP;


-- QUERY CORRECTE (esborra competicio, competicio_temporada i cursa)
call baixa_competicio (11, @RSP);
SELECT @RSP;

-- ERROR: Codi competició inexistent
call baixa_competicio (52, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA FABRICANT preparacio

-- A l'script INSERIR_DADES s'ha inserit el 'Fabricant de prova baixa' per fer aquesta prova

-- Es creau un component per al 'Fabricant de prova baixa'
call alta_component (47,1,'TestComponent','Prova descripció', @RSP);
SELECT @RSP;

-- La dada telmètrica ha de ser coherent:
-- - El component (codi 137) és d'un cotxe (codi 1) que va correr la cursa amb data 2015-01-15
call alta_telemetria(137, '2015-01-15','velocitat', FLOOR(RAND()*(400-0)+0),'kmh', @RSP);
SELECT @RSP;

-- QUERY CORRECTE, esborra els components relatius (y la telemetria dels components)
call baixa_fabricant(47, @RSP);
SELECT @RSP;

-- ERROR: Codi del fabricant inexistent
call baixa_fabricant(501, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA TELEMETRIA preparacio

-- La dada telmètrica ha de ser coherent:
-- - El component és del cotxe que va correr la cursa amb data 2014-01-15
call alta_telemetria(103,'2014-01-15','velocitat', FLOOR(RAND()*(400-0)+0),'kmh', @RSP);
SELECT @RSP;

-- QUERY CORRECTE (@Paràmetres: codi de la dada telemètrica).
call baixa_telemetria (1, @RSP);
SELECT @RSP;

-- ERROR: codi de la dada telemètrica inexistent.
call baixa_telemetria (6666661, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA COMPONENT preparacio

-- A l'script INSERIR_DADES s'ha inserit el component 'TestComponent baixa' (codi 137) per a provar aquest procediment

-- Es dóna d'alta un adada telemètrica amb el codi del component que acabem de crear.
-- La dada telmètrica ha de ser coherent:
-- - El component és del cotxe que va correr una cursa amb data 2015-01-15

call alta_telemetria(137,'2015-01-15','velocitat', FLOOR(RAND()*(400-0)+0),'kmh', @RSP);
SELECT @RSP;

-- QUERY CORRECTE, esborra també telemetria. (@Paràmetres: codi del component).
call baixa_component (137, @RSP);
SELECT @RSP;

-- ERROR: codi del component inexistent.
call baixa_component (1103, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA PATROCINADOR preparacio

-- A l'script INSERIR_DADES s'ha inserit el patrocinador 'Test patrocinador baixa' (codi 13) per a provar aquest procediment

call alta_patrocini (13, 1, 2015, 1123454, @RSP);
SELECT @RSP;

call alta_patrocini (13, 2, 2015, 198765432, @RSP);
SELECT @RSP;

-- QUERY CORRECTE, esborra els patrocinis relatius. (@Paràmetres: codi del patrocinador).
call baixa_patrocinador (13, @RSP);
SELECT @RSP;

-- ERROR: codi del patrocinador inexistent.
call baixa_patrocinador (133, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA PATROCINI preparacio
call alta_patrocini (2, 2, 2015, 676414212, @RSP);
SELECT @RSP;

-- QUERY CORRECTE  (@Paràmetres: codi del patrocinador, de l'equip i la temporada).
call baixa_patrocini(2, 2, 2015, @RSP);
SELECT @RSP;

-- ERROR: codi del patrocinador inexistent.
call baixa_patrocini(222, 37, 2015, @RSP);
SELECT @RSP;

-- ERROR: codi de l'equip inexistent.
call baixa_patrocini(2, 3722, 2015, @RSP);
SELECT @RSP;

-- ERROR: temporada inexistent.
call baixa_patrocini(2, 37, 2115, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA TEMPORADA preparacio
call alta_temporada (2054, 1, @RSP);
SELECT @RSP;

-- QUERY CORRECTE.  (@Paràmetres: temporada i codi de la competició).
call baixa_temporada(2054, 1, @RSP);
SELECT @RSP;

-- ERROR: temporada inexistent.
call baixa_temporada(2064, 1, @RSP);
SELECT @RSP;


-- ERROR: codi de la competició inexistent
call baixa_temporada(2054, 231, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA PAIS preparacio
call alta_pais ('ZZ', 'Peteronia', @RSP);
SELECT @RSP;

-- QUERY CORRECTE. (@Paràmetres: codi del país).
call baixa_pais('ZZ', @RSP);
SELECT @RSP;

-- ERROR: codi del país inexistent.
call baixa_pais('XX', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA SECTOR preparacio

-- IMPORTANT: El procediment alta_sector de vegades dóna un error al resultat però l'acció s'executa correctament
-- Sembla un bug de MySQL.
call alta_sector ('Sector de prova baixa', @RSP);
SELECT @RSP;

-- Crear un patrocinador que pertanyi al sector creat
call alta_patrocinador (16, 'Patrocinador baixa sector', @RSP);
SELECT @RSP;

-- QUERY CORRECTE, no esborra els patrocinadors relacionats, el camp es queda a null
call baixa_sector (16, @RSP);
SELECT @RSP;

-- ERROR: Codi del sector inexistent.
call baixa_sector (171, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA EQUIP preparacio

-- A l'script INSERIR_DADES s'ha inserit l'equip 'Scuderia de prova baixa' (codi 27) per a provar aquest procediment

-- Crear un nou pilot a l'equip creat (codi 27).
call alta_pilot ('Test_pilot', 'ES', 27, 'TS123456', 2015, @RSP);
SELECT @RSP;

-- Crear un nou cotxe a l'equip creat (codi 27).
call alta_cotxe ('testmodel',2014,27,2014, @RSP);
select @RSP;

-- Crear un nou component per al cotxe creat (codi 19).
call alta_component (1,19,'Test Component baixa equip','Prova descripció', @RSP);
SELECT @RSP;

-- Crear una nova dada teleme`trica per al component creat (codi 139).
call alta_telemetria(139,'2015-01-01','velocitat', FLOOR(RAND()*(400-0)+0),'kmh', @RSP);
SELECT @RSP;

-- Crear un nou director a l'equip creat (codi 27).
call alta_director ('Test_director baixa equip', 'ES', 27, 'Mechanical engineer', 2015, @RSP);
select @RSP;

-- Crear un nou cotxe per l'equip creat (codi 27).
call alta_patrocini (1, 27, 2015, 155555, @RSP);
SELECT @RSP;


-- QUERY CORRECTE, esborra també director, pilot, cotxe, components, telemetria i patrocinis.
call baixa_equip (27, @RSP);
SELECT @RSP;

-- ERROR: Codi de l'equip inexistent.
call baixa_equip (656, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA COTXE preparacio

-- Avís: adaptar les FK a cada comanda després d'executar l'anterior,
-- Els valors per defecte poden no coincidir si s'han fet altres modificacions a la BD.

call alta_equip ('Scuderia de prova', 'Barcelona', '2015-11-13', @RSP);
SELECT @RSP;

-- Crear un nou cotxe a l'equip creat (codi 28).
call alta_cotxe ('testmodel',2014,28,2014, @RSP);
select @RSP;

-- Crear un nou component per al cotxe creat (codi 20).
call alta_component (1,20,'Test Component baixa equip','Prova descripció', @RSP);
SELECT @RSP;

-- Crear una nova dada teleme`trica per al component creat (codi 151).
call alta_telemetria(151,'2015-01-01','velocitat', FLOOR(RAND()*(400-0)+0),'kmh', @RSP);
SELECT @RSP;

-- QUERY CORRECTE, esborra també components i telemetria.
call baixa_cotxe (20 , @RSP);
SELECT @RSP;

-- ERROR: Codi del cotxe inexistent.
call baixa_cotxe (656, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA RETRANSMISSIÓ preparacio
call alta_retransmissio (10, 'BR', 2, @RSP);
SELECT @RSP;

-- QUERY CORRECTE
call baixa_retransmissio (10,2, @RSP);
SELECT @RSP;

-- ERROR: Codi de l'emissora inexistent.
call baixa_retransmissio (656,19, @RSP);
SELECT @RSP;

-- ERROR: Codi de la competició inexistent.
call baixa_retransmissio (22,199, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA EMISSORA preparacio

-- A l'script INSERIR_DADES s'ha inserit l'emissora 'emissora prova baixa' (codi 13) per a provar aquest procediment

-- Es crea una retransmissió per a la nova emissora (codi 13).
call alta_retransmissio (13,'ES',1, @RSP);
SELECT @RSP;

-- QUERY CORRECTE (esborra tb retransmissió si existeix alguna)
call baixa_emissora (13, @RSP);
SELECT @RSP;

-- ERROR: codi de l'emissora inexistent.
call baixa_emissora (1103, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA PILOT preparacio
call alta_pilot ('Test_pilot', 'ES', 2, 'TS123456', 2015, @RSP);
SELECT @RSP;

-- QUERY CORRECTE (esborra tb persona)
-- AVÍS: corregir el codi 26 si no és el correcte per al pilot creat.
call baixa_pilot (26, @RSP);
SELECT @RSP;

-- ERROR: codi de persona inexistent.
call baixa_pilot (1103, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA DIRECTOR preparacio
call alta_director ('Test_director', 'ES', 6, 'Mechanical engineer', 2015, @RSP);
select @RSP;

-- QUERY CORRECTE (esborra tb persona)
-- AVÍS: corregir el codi 27 si no és el correcte per al pilot creat.
call baixa_director (27, @RSP);
select @RSP;

-- ERROR: codi de persona inexistent.
call baixa_director (1103, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- BAIXA CURSA preparacio
call alta_cursa (18, 11,2, 1,'2015-03-01', @RSP);
select @RSP;
call alta_cursa (18, 12,2, 0,'2015-03-01', @RSP);
select @RSP;

-- QUERY CORRECTE
call baixa_cursa (18, 11,2,,'2015-03-01', @RSP);
select @RSP;
call baixa_cursa (18, 12,2,'2015-03-01', @RSP);
select @RSP;

-- ERROR: circuit inexistent.
call baixa_cursa (128, 11,2,'2015-03-01', @RSP);
select @RSP;

-- ERROR: pilot inexistent.
call baixa_cursa (18, 1111,2,'2015-03-01', @RSP);
select @RSP;

-- ERROR: competicio inexistent.
call baixa_cursa (18, 11,322,'2015-03-01', @RSP);
select @RSP;

-- ERROR: data inexistent.
call baixa_cursa (18, 11,2,'2035-03-01', @RSP);
select @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------


