-- Inserir algunes dades defectuoses
call alta_telemetria(115,'2015-01-15','velocitat', 4000,'kmh', @RSP);
SELECT @RSP;
call alta_telemetria(103,'2015-01-15','velocitat', 4000,'kmh', @RSP);
SELECT @RSP;
call alta_telemetria(3,'2015-01-15','consum', -5,'lps', @RSP);
SELECT @RSP;
call alta_telemetria(9,'2015-01-15','consum', -4,'lps', @RSP);
SELECT @RSP;


-- Cercar els percentatges de components defectuosos de cada cotxe (mòdul estadístic 1)

call me_components_defectuosos();


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- Cercar el resultat de cada pilot en cada competició disputada (mòdul estadístic 2)

call me_resultat_pilots();


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- Cercar els 10 pilots que han acabat més carreres (mòdul estadístic 3)

call me_carreres_finalitzades();


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- Mostrar la classificació de cada competició (mòdul estadístic 4)

-- Per exemple, a la Fòrmula 1 (competició 1) al 2015 
call me_classificacio(1,2015);


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- Cercar les 10 voltes més ràpides donades a un circuit determinat (mòdul estadístic 5)

-- Per exemple, al circuit 3:
call me_volta_rapida(3);


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- Cercar la temperatura més alta enregistrada al sistema (mòdul estadístic 6)

call me_temperatura_maxima();


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- Mostrar el TOP-5 de patrocinadors que aporten més diners als equips (mòdul estadístic 7)

call me_top_patrocinadors();


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------


-- Mostrar el volum de dades telemètriques enregistrades al sistema a un any concret 
-- i l'equip amb més dades enregistrades aquell any (mòdul estadístic 8)

-- Per exemple, al 2015

call me_dades_telemetriques(2015);


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- Mostrar el TOP-5 de fabricants que aporten més components (mòdul estadístic 9)

call me_top_fabricants();


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- Cercar els 10 pilots que han guanyat més carreres (mòdul estadístic 10)

call me_curses_guanyades();


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- Dades del pilot amb la millor evolució (mòdul estadístic 11)

-- Per exemple, entre el 2015-01-01 i el 2015-03-01

call me_millor_evolucio('2015-01-01', '2015-03-01');


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- Cercar quin és el cotxe que porta consumit més carburant per competició (mòdul estadístic 12)

-- Per exemple, a la Fòrmula 1 (competició 1) al 2015 

call me_consum_maxim(2015, 1);


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------



-- PROCEDIMENTS ADDICONALS d'ESTADÍSTIQUES ABSOLUTES

-- Aquests procediments fan servir les dades emmagatzemades a les taules per a
-- generar les estadístiques. S'esborren primer les dades de les taules dim i de fets
-- i s'omplen amb les noves dades. Per a provar-ho, esborrar manualment totes les dades
-- de la taula de fets i les complementàries i executar els procediments següents.


call estadistica_classificacio_pilots();

call estadistica_consum_total();

call estadistica_curses_finalitzades();

call estadistica_curses_resultat();

call estadistica_patrocini_maxim();

call estadistica_quantitat_components();

call estadistica_temperatura_maxima();

call estadistica_volta_rapida();

call estadistica_volum_telemetria();

-- L'estadística de components defectuosos no ha estat coberta amb aquest mètode (si amb l'incremental)






