-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ CIRCUIT

-- QUERY CORRECTE.
call modificacio_circuit (75,'Test modificació circuit', 'test_sobrenom modificat', 6666, 'ES', @RSP);
SELECT @RSP;


-- ERROR: codi circuit inexistent.
call modificacio_circuit (775,'Test modificació circuit 2', 'test_sobrenom modificat 2', 6666, 'ES', @RSP);
SELECT @RSP;

-- ERROR: nom del circuit en ús.
call modificacio_circuit (75,'Hockenheimring', 'test_sobrenom modificat 2', 6666, 'ES', @RSP);
SELECT @RSP;

-- ERROR: sobrenom del circuit en ús.
call modificacio_circuit (75,'Test modificació circuit 2', 'hungaroring', 6666, 'ES', @RSP);
SELECT @RSP;

-- ERROR: Longitud del circuit massa petita
call modificacio_circuit (75,'Test modificació circuit 2', 'test_sobrenom modificat 2', 10, 'ES', @RSP);
SELECT @RSP;


-- ERROR: Longitud del circuit massa petita
-- AVÍS: el control d'errors no tracta bé de vegades aquesta excepció (bug mysql).
call modificacio_circuit (75,'Test modificació circuit 2', 'test_sobrenom modificat 2', 6666, 'ZS', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ COMPETICIÓ 

-- QUERY CORRECTE.
call modificacio_competicio(12, 'testcomp_mod','TC_mod','Prova descripció_mod', @RSP);
SELECT @RSP;


-- ERROR: Codi de competicio inexistent.
call modificacio_competicio(1112, 'testcomp_mod','TC_mod','Prova descripció_mod', @RSP);
SELECT @RSP;

-- ERROR: Acrònim de competició en ús.
call modificacio_competicio(12, 'testcomp_mod','F1','Prova descripció', @RSP);
SELECT @RSP;

-- ERROR: Nom de competició en ús.
call modificacio_competicio(12, 'Fórmula 1','TC_mod','Prova descripció', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ COMPONENT

-- QUERY CORRECTE
call modificacio_component (100,2,10,'TestComp modificat','Prova descripció_modificat', @RSP);
SELECT @RSP;


-- ERROR: codi component inexistent
call modificacio_component (666,2,10,'TestComp2','Prova descripció_mod2', @RSP);
SELECT @RSP;

-- ERROR: fabricant inexistent
-- AVÍS: el control d'errors no tracta bé de vegades aquesta excepció (bug mysql).
call modificacio_component (100,959,10,'TestComp2','Prova descripció_mod2', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ COTXE

-- QUERY CORRECTE
call modificacio_cotxe (6,'testmodel_modificat', 2015, @RSP);
SELECT @RSP;


-- ERROR: codi cotxe inexistent
call modificacio_cotxe (145,'testmodel_modificat', 2015, @RSP);
SELECT @RSP;

-- ERROR: Nom del cotxe en ús.
call modificacio_cotxe (13,'Hyundai i20WRC', 2015, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ CURSA

-- Preparació
call alta_cursa (20, 6, 1, 1, '2015-04-04', @RSP);
SELECT @RSP;

-- QUERY CORRECTE (posició modificada)
call modificacio_cursa(20, 6, 1, 3, '2015-04-15', @RSP);
SELECT @RSP;


-- ERROR: codi circuit inexistent
call modificacio_cursa(565, 23, 1, 3, '2015-04-15', @RSP);
SELECT @RSP;

-- ERROR: codi pilot inexistent
call modificacio_cursa(5, 231, 1, 3, '2015-04-15', @RSP);
SELECT @RSP;

-- ERROR: codi competició inexistent
call modificacio_cursa(5, 23, 122, 3, '2015-04-15', @RSP);
SELECT @RSP;

-- ERROR: data inexistent per aquesta competició
call modificacio_cursa(5, 23, 1, 3, '2065-04-15', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ DIRECTOR


-- QUERY CORRECTE (nacionalitat i professió modificades)
call modificacio_director (5, 'Éric Boullier', 'ES', 5, 'Mechanical engineer', 2013, @RSP);
select @RSP;


-- ERROR: codi persona inexistent
call modificacio_director (543, 'Éric Boullier', 'ES', 5, 'Mechanical engineer', 2013, @RSP);
select @RSP;

-- ERROR: codi país inexistent
call modificacio_director (5, 'Éric Boullier', 'XS', 5, 'Mechanical engineer', 2013, @RSP);
select @RSP;

-- ERROR: codi de l'equip inexistent
call modificacio_director (5, 'Éric Boullier', 'ES', 235, 'Mechanical engineer', 2013, @RSP);
select @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ EMISSORA


-- QUERY CORRECTE (nacionalitat i nom modificats)
call modificacio_emissora (7,'emissora-test_modificada', 'GB', @RSP);
select @RSP;


-- ERROR: codi país inexistent
call modificacio_emissora (7,'emissora-test_modificada', 'XS', @RSP);
select @RSP;

-- ERROR: codi emissora inexistent
call modificacio_emissora (170,'emissora-test_modificada', 'GB', @RSP);
select @RSP;

-- ERROR: ja existeix una emissora amb aquest nom a aquest país
call modificacio_emissora (7,'RTL', 'DE', @RSP);
select @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ EQUIP


-- QUERY CORRECTE (seu, debut i nom modificats)
call modificacio_equip (20, 'Scuderia_modificada', 'Reus', '2014-12-25', @RSP);
SELECT @RSP;


-- ERROR: codi equip inexistent
call modificacio_equip (2021, 'Scuderia_modificada', 'Reus', '2014-12-25', @RSP);
SELECT @RSP;

-- ERROR: Nom d'equip en ús.
call modificacio_equip (20, 'McLaren Honda', 'Reus', '2014-12-25', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ FABRICANT


-- QUERY CORRECTE (any_debut i nom modificats)
call modificacio_fabricant (22,'fabricant_modificat', 1965, @RSP);
SELECT @RSP;


-- ERROR: Nom del fabricant en ús.
call modificacio_fabricant (22,'Enkei', 1965, @RSP);
SELECT @RSP;

-- ERROR: Codi del fabricant inexistent.
call modificacio_fabricant (2332,'Enkei', 1965, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ PAÍS


-- QUERY CORRECTE (nom modificat)
call modificacio_pais ('ZW', 'Zimbawe_modificat', @RSP);
SELECT @RSP;


-- ERROR: Codi del país inexistent.
call modificacio_pais ('ZX', 'Zimbawe_modificat', @RSP);
SELECT @RSP;

-- ERROR: Nom del país en ús.
call modificacio_pais ('ZW', 'Spain', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ PATROCINADOR


-- QUERY CORRECTE (sector i nom modificats)
call modificacio_patrocinador (7,4,'banc_modificat', @RSP);
SELECT @RSP;


-- ERROR: Codi del patrocinador inexistent.
call modificacio_patrocinador (117,4,'banc_modificat', @RSP);
SELECT @RSP;

-- ERROR: Codi del sector inexistent.
call modificacio_patrocinador (7,111,'banc_modificat', @RSP);
SELECT @RSP;

-- ERROR: Nom del patrocinador en ús.
call modificacio_patrocinador (7,4,'Santander', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ PATROCINI ((només l'any i el cost es poden modificar, les altres son la PK)

-- QUERY CORRECTE (cost modificat)
call modificacio_patrocini (1, 1, 2014, 777777, @RSP);
SELECT @RSP;


-- ERROR: Codi del patrocinador inexistent.
call modificacio_patrocini (221, 1, 2014, 777777, @RSP);
SELECT @RSP;

-- ERROR: Codi de l'equip inexistent.
call modificacio_patrocini (1, 134, 2014, 777777, @RSP);
SELECT @RSP;

-- ERROR: Temporada inexistent.
call modificacio_patrocini (1, 1, 2074, 777777, @RSP);
SELECT @RSP;

-- ERROR: Patrocini massa petit
call modificacio_patrocini (1, 1, 2014, 100, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ PILOT


-- QUERY CORRECTE (nacionalitat, llicència, any_inici i nom modificats)
call modificacio_pilot (20, 'Test_pilot_modificat', 'GB', 15, 'TS666666', 2016, @RSP);
SELECT @RSP;


-- ERROR: Codi de la persona inexistent.
call modificacio_pilot (520, 'Test_pilot_modificat', 'GB', 15, 'TS666666', 2016, @RSP);
SELECT @RSP;

-- ERROR: Codi del país inexistent.
call modificacio_pilot (20, 'Test_pilot_modificat', 'XX', 15, 'TS666666', 2016, @RSP);
SELECT @RSP;

-- ERROR: Codi de l'equip inexistent.
call modificacio_pilot (20, 'Test_pilot_modificat', 'GB', 541, 'TS666666', 2016, @RSP);
SELECT @RSP;

-- ERROR: Codi de llicencia duplicat
call modificacio_pilot (20, 'Test_pilot_modificat', 'GB', 15, 'ME789985', 2016, @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ SECTOR


-- QUERY CORRECTE (nom modificat)
call modificacio_sector(10,'Sanitat modificada', @RSP);
SELECT @RSP;


-- ERROR: Codi del sector inexistent.
call modificacio_sector(69,'Sanitat modificada', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ TELEMETRIA


-- QUERY CORRECTE (moment i temps  modificats)
call modificacio_telemetria(1,103, '2015-01-15 12:10:23.000000','temps per volta', 250000,'ms', @RSP);
SELECT @RSP;


-- ERROR: Codi del components inexistent.
call modificacio_telemetria(1,12303, '2015-01-15 12:10:23.000000','temps per volta', 250000,'ms', @RSP);
SELECT @RSP;

-- ERROR: Valor de la dada incorrecte.
call modificacio_telemetria(1,103, '2015-01-15 12:10:23.000000','temps per volta', -5,'ms', @RSP);
SELECT @RSP;


-- ---------------------------------------------------------------------------------------
-- ---------------------------------------------------------------------------------------

-- MODIFICACIÓ TEMPORADA

-- Preparació
call alta_temporada (2042, 6, @RSP);
SELECT @RSP;

-- QUERY CORRECTE (any i competició  modificats)
call modificacio_temporada (2042, 6, 2015, 8, @RSP);
SELECT @RSP;



